diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/Buffer.java b/game/client/src/main/java/net/minecraft/client/util/helper/Buffer.java
similarity index 80%
rename from game/core/src/main/java/net/minecraft/core/util/helper/Buffer.java
rename to game/client/src/main/java/net/minecraft/client/util/helper/Buffer.java
index f6e3a2ba1..8304a7697 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/Buffer.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/Buffer.java
@@ -1,4 +1,8 @@
-package net.minecraft.core.util.helper;
+package net.minecraft.client.util.helper;
+
+import net.minecraft.core.util.helper.Color;
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.BufferUtils;
 
 import java.awt.image.BufferedImage;
 import java.nio.ByteBuffer;
@@ -6,22 +10,17 @@ import java.nio.ByteOrder;
 
 public abstract class Buffer {
 	
-	public static ByteBuffer buffer = createBuffer(2097152);
-	
-	public static ByteBuffer createBuffer(int size) {
-		return ByteBuffer.allocateDirect(size).order(ByteOrder.nativeOrder());
-	}
+	public static ByteBuffer buffer = BufferUtils.createByteBuffer(2097152);
 	
 	public static void checkBufferSize(int size) {
 		if(buffer.capacity() < size) {
-			buffer = createBuffer(size);
+			buffer = BufferUtils.createByteBuffer(size);
 			System.out.println("Expanding buffer to "+size);
 		}
 	}
 	
 	public static void reset() {
-		buffer.position(0);
-		buffer.limit(buffer.capacity());
+		buffer.clear();
 	}
 	
 	public static int getInt(int i) {
@@ -41,7 +40,7 @@ public abstract class Buffer {
         buffer.flip();
 	}
 
-	public static void put(BufferedImage image) {
+	public static void put(@NotNull BufferedImage image) {
 		checkBufferSize(image.getWidth() * image.getHeight() * 4);
 		reset();
 		
@@ -70,7 +69,7 @@ public abstract class Buffer {
 		put4Bytes(i, r, g, b, a);
 	}
 
-	public static void putColor(int i, Color color) {
+	public static void putColor(int i, @NotNull Color color) {
 		putARGB(i, color.value);
 	}
 	
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java b/game/client/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java
index 87889a252..86d2ff837 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.util.helper;
 
-import static net.minecraft.core.util.helper.Buffer.*;
+import static net.minecraft.client.util.helper.Buffer.*;
 import static org.lwjgl.opengl.ARBFramebufferObject.*;
 import static org.lwjgl.opengl.GL11.*;
 import static org.lwjgl.opengl.GL12.GL_CLAMP_TO_EDGE;
@@ -16,7 +16,6 @@ import net.minecraft.client.render.FrameBuffer;
 import net.minecraft.client.render.Renderer;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.core.Global;
-import net.minecraft.core.util.helper.Buffer;
 
 public class ScreenshotHelper {
 	
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/Textures.java b/game/client/src/main/java/net/minecraft/client/util/helper/Textures.java
index 5cf5452c2..332168a12 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/Textures.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/Textures.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.util.helper;
 
-import static net.minecraft.core.util.helper.Buffer.*;
+import static net.minecraft.client.util.helper.Buffer.*;
 import static org.lwjgl.opengl.GL11.*;
 
 import java.awt.Color;
@@ -12,15 +12,12 @@ import java.io.File;
 import java.io.IOException;
 import java.io.InputStream;
 import java.nio.ByteBuffer;
-import java.util.List;
 
 import javax.imageio.ImageIO;
 
 import com.mojang.logging.LogUtils;
 import it.unimi.dsi.fastutil.ints.IntList;
-import net.minecraft.client.render.texture.stitcher.AtlasStitcher;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.core.util.helper.Buffer;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL12;
 
diff --git a/game/client/src/main/java/org/useless/dragonfly/models/block/StaticBlockModel.java b/game/client/src/main/java/org/useless/dragonfly/models/block/StaticBlockModel.java
index 4d8d941fb..09ad1bf82 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/block/StaticBlockModel.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/block/StaticBlockModel.java
@@ -3,7 +3,6 @@ package org.useless.dragonfly.models.block;
 import net.minecraft.client.render.block.color.BlockColor;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
-import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
@@ -22,7 +21,7 @@ public interface StaticBlockModel {
     /**
      * @return True if anything rendered, false otherwise
      */
-    boolean renderAttached(@NotNull BlockModel<? extends BlockLogic> sourceModel, @NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, int x, int y, int z, double xOff, double yOff, double zOff, boolean cullFaces, @Nullable IconCoordinate overrideTexture);
+    boolean renderAttached(@NotNull BlockModel<? extends BlockLogic> sourceModel, @NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, int x, int y, int z, double xOff, double yOff, double zOff, boolean cullFaces, @Nullable IconCoordinate overrideTexture);
 
     /**
      * @return Block texture to overlay when inside a block
diff --git a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
index 58d3241bf..057e81576 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
@@ -9,7 +9,6 @@ import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelStandard;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
-import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Color;
@@ -26,9 +25,7 @@ import org.useless.dragonfly.models.block.StaticBlockModel;
 
 import java.util.Locale;
 
-import static net.minecraft.client.render.block.model.BlockModel.ENABLE_DIRECTIONAL_LIGHTING;
 import static net.minecraft.client.render.block.model.BlockModel.FULL_CUBE_THRESHOLD;
-import static net.minecraft.client.render.block.model.BlockModel.SIDE_LIGHT_MULTIPLIER;
 import static org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData.C_Element.FLOATS_PER_NORMAL;
 import static org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData.C_Element.FLOATS_PER_VERTEX;
 import static org.useless.dragonfly.data.block.mojang.CompiledBlockModelMojangData.C_Element.NORMAL_FLOAT_X;
@@ -98,7 +95,7 @@ public class StaticBlockModelMojang implements StaticBlockModel {
     }
 
     @Override
-    public boolean renderAttached(@NotNull BlockModel<? extends BlockLogic> sourceModel, @NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, int x, int y, int z, double xOff, double yOff, double zOff, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+    public boolean renderAttached(@NotNull BlockModel<? extends BlockLogic> sourceModel, @NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, int x, int y, int z, double xOff, double yOff, double zOff, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
         if (this.compiled.elements.length == 0) return false;
         boolean didRender = false;
         LIGHTING_CACHE.setupCache(sourceModel.block, worldSource, x, y, z);
@@ -307,18 +304,17 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                     lightTL = lightBL = lightBR = lightTR = getBrightness(dirX2, dirY2, dirZ2, minBrightness);
                 }
 
-                final float sideLight = (element.shade && ENABLE_DIRECTIONAL_LIGHTING) ? SIDE_LIGHT_MULTIPLIER[direction.getId()] : 1;
-                float colorRedBottomLeft = r * sideLight;
+                float colorRedBottomLeft = r;
                 float colorRedBottomRight = colorRedBottomLeft;
                 float colorRedTopRight = colorRedBottomLeft;
                 float colorRedTopLeft = colorRedBottomLeft;
 
-                float colorGreenBottomLeft = g * sideLight;
+                float colorGreenBottomLeft = g;
                 float colorGreenBottomRight = colorGreenBottomLeft;
                 float colorGreenTopRight = colorGreenBottomLeft;
                 float colorGreenTopLeft = colorGreenBottomLeft;
 
-                float colorBlueBottomLeft = b * sideLight;
+                float colorBlueBottomLeft = b;
                 float colorBlueBottomRight = colorBlueBottomLeft;
                 float colorBlueTopRight = colorBlueBottomLeft;
                 float colorBlueTopLeft = colorBlueBottomLeft;
@@ -349,6 +345,7 @@ public class StaticBlockModelMojang implements StaticBlockModel {
 
                 final int offset = face * 4 * FLOATS_PER_VERTEX;
 
+                tessellator.setNormal(direction.getOffsetX(), direction.getOffsetY(), direction.getOffsetZ());
                 tessellator.setColorOpaque3f(colorRedTopLeft, colorGreenTopLeft, colorBlueTopLeft);
                 tessellator.setLightmapCoord1i(lightmapCoordTopLeft);
                 tessellator.addVertexWithUV(
@@ -385,6 +382,7 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                     coordinate.getSubIconU(element.vertexData[offset + VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX + VERTEX_FLOAT_U]),
                     coordinate.getSubIconV(element.vertexData[offset + VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX + VERTEX_FLOAT_V]));
 
+                tessellator.setNormal(0, 1, 0);
                 didRender = true;
             }
         }
diff --git a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
index 353e0bad8..2b2969cd3 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
@@ -27,7 +27,7 @@ import java.util.Map;
 
 public class StaticEntityModelMojang implements StaticEntityModel {
     private static final BoneTransform DUMMY_TRANSFORM = new BoneTransform();
-    private static final TessellatorEntity entityTessellator = new TessellatorEntity(2048);
+    private static final TessellatorEntity entityTessellator = new TessellatorEntity(8192);
     public final @NotNull Map<@NotNull String, @NotNull BoneTransform> transformMap = new Object2ObjectOpenHashMap<>();
     public final @NotNull BoneTransform @NotNull [] transforms;
     public final @NotNull Bone @NotNull [] bones;
diff --git a/game/client/src/main/resources/shaders/clouds.fsh b/game/client/src/main/resources/shaders/clouds.fsh
index dcaad24a3..707540157 100644
--- a/game/client/src/main/resources/shaders/clouds.fsh
+++ b/game/client/src/main/resources/shaders/clouds.fsh
@@ -26,8 +26,8 @@ layout (std140) uniform Matrices {
 uniform int isEyeInLiquid;
 uniform vec2 uViewPortSize;
 
-uniform sampler2D texture0;
-uniform sampler2D texture1;
+uniform sampler2D colortex;
+uniform sampler2D lighttex;
 
 float distance() {
 	vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0f - 1.0f, gl_FragCoord.z * 2.0f - 1.0f, 1.0f);
@@ -37,7 +37,7 @@ float distance() {
 }
 
 void main() {
-	vec4 tex = texture(texture0, TexCoord);
+	vec4 tex = texture(colortex, TexCoord);
 	
 	// Alpha test
 	if(tex.a < 0.1f) {
diff --git a/game/client/src/main/resources/shaders/color_world.fsh b/game/client/src/main/resources/shaders/color_world.fsh
index dcfc19dd5..f74eec6b4 100644
--- a/game/client/src/main/resources/shaders/color_world.fsh
+++ b/game/client/src/main/resources/shaders/color_world.fsh
@@ -24,7 +24,7 @@ layout (std140) uniform Matrices {
     mat4 viewInv;
 } matrices;
 
-uniform sampler2D texture1;
+uniform sampler2D lighttex;
 
 float distance() {
     vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0f - 1.0f, gl_FragCoord.z * 2.0f - 1.0f, 1.0f);
@@ -64,7 +64,7 @@ vec4 computeFog(vec4 color) {
 }
 
 void main() {
-    vec4 lightColor = texture(texture1, LightMapCoord);
+    vec4 lightColor = texture(lighttex, LightMapCoord);
 
     vec4 oColor = lightColor * Color * uColor;
     vec4 litColor = vec4(oColor.rgb * clamp(Light, 0, 1), oColor.a);
diff --git a/game/client/src/main/resources/shaders/font.fsh b/game/client/src/main/resources/shaders/font.fsh
index b347f8cba..a5146ab49 100644
--- a/game/client/src/main/resources/shaders/font.fsh
+++ b/game/client/src/main/resources/shaders/font.fsh
@@ -7,11 +7,11 @@ in vec2 Lightmap;
 
 uniform vec4 uColor;
 
-uniform sampler2D texture0;
-uniform sampler2D texture1;
+uniform sampler2D colortex;
+uniform sampler2D lighttex;
 
 void main() {
-    FragColor = texture(texture0, TexCoord) * texture(texture1, Lightmap) * Color * uColor;
+    FragColor = texture(colortex, TexCoord) * texture(lighttex, Lightmap) * Color * uColor;
     if (FragColor.a < 0.1f) {
         discard;
     }
diff --git a/game/client/src/main/resources/shaders/interface.fsh b/game/client/src/main/resources/shaders/interface.fsh
index 8017968fb..d06927a62 100644
--- a/game/client/src/main/resources/shaders/interface.fsh
+++ b/game/client/src/main/resources/shaders/interface.fsh
@@ -6,8 +6,8 @@ in vec4 Color;
 in vec2 TexCoord;
 
 uniform vec4 uColor;
-uniform sampler2D texture0;
+uniform sampler2D colortex;
 
 void main() {
-    FragColor = texture(texture0, TexCoord) * Color * uColor;
+    FragColor = texture(colortex, TexCoord) * Color * uColor;
 }
diff --git a/game/client/src/main/resources/shaders/particle.fsh b/game/client/src/main/resources/shaders/particle.fsh
index f7ffa5db6..2d23f4c9e 100644
--- a/game/client/src/main/resources/shaders/particle.fsh
+++ b/game/client/src/main/resources/shaders/particle.fsh
@@ -5,11 +5,11 @@ in vec4 Color;
 in vec2 TexCoord;
 in vec2 Lightmap;
 
-uniform sampler2D texture0;
-uniform sampler2D texture1;
+uniform sampler2D colortex;
+uniform sampler2D lighttex;
 
 void main() {
-    FragColor = texture(texture0, TexCoord) * texture(texture1, Lightmap) * Color;
+    FragColor = texture(colortex, TexCoord) * texture(lighttex, Lightmap) * Color;
     if (FragColor.a < 0.1f) {
         discard;
     }
diff --git a/game/client/src/main/resources/shaders/terrain.fsh b/game/client/src/main/resources/shaders/terrain.fsh
new file mode 100644
index 000000000..e7b0b1e1f
--- /dev/null
+++ b/game/client/src/main/resources/shaders/terrain.fsh
@@ -0,0 +1,91 @@
+#version 410 core
+
+out vec4 FragColor;
+
+in vec4 Color;
+in vec2 TexCoord;
+in vec2 LightMapCoord;
+in vec3 Light;
+
+uniform vec4 uColor;
+uniform vec2 uViewPortSize;
+
+layout (std140) uniform FogState {
+    vec4 color;
+    int mode;
+    float start;
+    float end;
+    float density;
+} fogState;
+
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
+
+uniform sampler2D colortex;
+uniform sampler2D lighttex;
+uniform sampler2D emmisivetex;
+//uniform sampler2D colormasktex;
+
+float distance() {
+    vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0f - 1.0f, gl_FragCoord.z * 2.0f - 1.0f, 1.0f);
+    fragPos /= fragPos.w;
+
+    return length(fragPos.xyz);
+}
+
+// Taken from https://github.com/hughsk/glsl-fog
+float fogFactorLinear() {
+    return 1.0 - clamp(((fogState.end - (distance())) / (fogState.end - fogState.start)), 0.0, 1.0);
+}
+
+float fogFactorExp() {
+    return 1.0 - clamp(exp(-fogState.density * (distance())), 0.0, 1.0);
+}
+
+float fogFactorExp2() {
+    float LOG2 = -1.442695;
+    float d = fogState.density * (distance());
+    return 1.0 - clamp(exp2(d * d * LOG2), 0.0, 1.0);
+}
+
+
+vec4 computeFog(vec4 color) {
+    float f = 0;
+    if (fogState.mode == 0) { // Linear
+        f = fogFactorLinear();
+    }
+    else if (fogState.mode == 1) { // EXP
+        f = fogFactorExp();
+    }
+    else if (fogState.mode == 2) { // EXP2
+        f = fogFactorExp2();
+    }
+    return vec4(mix(color.rgb, fogState.color.rgb, f), color.a);
+}
+
+void main() {
+    vec4 emmisiveColor = texture(emmisivetex, TexCoord);
+    vec4 lightColor = texture(lighttex, vec2(max(LightMapCoord.x, emmisiveColor.r), max(LightMapCoord.y, emmisiveColor.g)));
+    vec4 texColor = texture(colortex, TexCoord);
+    //    vec4 maskColor = texture(colormasktex, TexCoord);
+
+    vec4 oColor = texColor * lightColor;
+
+//    vec4 c = mix(vec4(1, 1, 1, 1), Color, maskColor.r);
+    vec4 c = Color;
+
+    vec4 postColor = oColor * c * uColor;
+    vec4 litColor = vec4(postColor.rgb * clamp(Light, 0, 1), postColor.a);
+
+    vec4 fColor = computeFog(litColor);
+
+
+    FragColor = fColor;
+    if (FragColor.a < 0.1f) {
+        discard;
+    }
+}
diff --git a/game/client/src/main/resources/shaders/terrain.vsh b/game/client/src/main/resources/shaders/terrain.vsh
new file mode 100644
index 000000000..4df0a92fb
--- /dev/null
+++ b/game/client/src/main/resources/shaders/terrain.vsh
@@ -0,0 +1,39 @@
+#version 410 core
+layout (location = 0) in vec3 aPos;
+layout (location = 1) in vec4 aColor;
+layout (location = 2) in vec2 aUV;
+layout (location = 3) in vec2 aLightmap;
+layout (location = 4) in vec3 aNormal;
+
+out vec4 Color;
+out vec2 TexCoord;
+out vec2 LightMapCoord;
+out vec3 Light;
+
+uniform mat4 normalTransform;
+uniform vec4 lightModelAmbient;
+uniform vec4 lightSourcePosition[];
+uniform vec4 lightSourceDiffuse[];
+
+uniform mat4 model;
+
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
+
+void main() {
+    vec4 p = vec4(aPos, 1);
+    gl_Position = matrices.projection * matrices.view * model * p;
+
+    TexCoord = aUV;
+    Color = aColor;
+    LightMapCoord = aLightmap;
+
+    vec3 norm = normalize(aNormal);
+    float d1 = max(0.0, dot(norm, vec3(-0.2f, 1f, -0.7f)));
+    float d2 = max(0.0, dot(norm, vec3( 0.2f, 1f,  0.7f)));
+    Light = vec3(0.5, 0.5, 0.5) + vec3(0.5, 0.5, 0.5) * clamp(d1 + d2, 0, 1);
+}
diff --git a/game/client/src/main/resources/shaders/world.fsh b/game/client/src/main/resources/shaders/world.fsh
index e4ecc285d..1dd6db044 100644
--- a/game/client/src/main/resources/shaders/world.fsh
+++ b/game/client/src/main/resources/shaders/world.fsh
@@ -25,8 +25,8 @@ layout (std140) uniform Matrices {
     mat4 viewInv;
 } matrices;
 
-uniform sampler2D texture0;
-uniform sampler2D texture1;
+uniform sampler2D colortex;
+uniform sampler2D lighttex;
 
 float distance() {
     vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0f - 1.0f, gl_FragCoord.z * 2.0f - 1.0f, 1.0f);
@@ -66,8 +66,8 @@ vec4 computeFog(vec4 color) {
 }
 
 void main() {
-    vec4 lightColor = texture(texture1, LightMapCoord);
-    vec4 texColor = texture(texture0, TexCoord);
+    vec4 lightColor = texture(lighttex, LightMapCoord);
+    vec4 texColor = texture(colortex, TexCoord);
 
     vec4 oColor = texColor * lightColor * Color * uColor;
     vec4 litColor = vec4(oColor.rgb * clamp(Light, 0, 1), oColor.a);
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java
index be264996d..37d3867d4 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java
@@ -35,19 +35,19 @@ public class BiomeProviderB173
         if (temperatures == null || temperatures.length < xSize * zSize) {
             temperatures = new double[xSize * zSize];
         }
-        this.temperatureMap.getValue(temperatures, x, z, xSize, xSize, 0.025, 0.025, 0.25);
+        this.temperatureMap.getRegion(temperatures, x, z, xSize, xSize, 0.025, 0.025, 0.25);
 
         if (humidities == null || humidities.length < xSize * zSize) {
             humidities = new double[xSize * zSize];
         }
-        this.downfallMap.getValue(humidities, x, z, xSize, xSize, 0.05, 0.05, 1.0 / 3.0);
+        this.downfallMap.getRegion(humidities, x, z, xSize, xSize, 0.05, 0.05, 1.0 / 3.0);
 
         if (varieties == null || varieties.length < xSize * zSize) {
             varieties = new double[xSize * zSize];
         }
         Arrays.fill(varieties, 0.0);
 
-        final double[] noises = this.noiseMap.getValue(null, x, z, xSize, xSize, 0.25, 0.25, 0.5882352941176471D);
+        final double[] noises = this.noiseMap.getRegion(null, x, z, xSize, xSize, 0.25, 0.25, 0.5882352941176471D);
 
         for (int xx = 0; xx < xSize; xx++) {
             for (int zz = 0; zz < zSize; zz++) {
@@ -94,8 +94,8 @@ public class BiomeProviderB173
             temperatures = new double[xSize * zSize];
         }
 
-        this.temperatureMap.getValue(temperatures, x, z, xSize, xSize, 0.025, 0.025, 0.25);
-        final double[] noises = this.noiseMap.getValue(null, x, z, xSize, zSize, 0.25, 0.25, 0.5882352941176471D);
+        this.temperatureMap.getRegion(temperatures, x, z, xSize, xSize, 0.025, 0.025, 0.25);
+        final double[] noises = this.noiseMap.getRegion(null, x, z, xSize, zSize, 0.25, 0.25, 0.5882352941176471D);
 
         int i = 0;
         for (int xx = 0; xx < xSize; xx++) {
@@ -126,7 +126,7 @@ public class BiomeProviderB173
             humidities = new double[xSize * zSize];
         }
 
-        return this.downfallMap.getValue(humidities, x, z, xSize, zSize, 0.05, 0.05, 0.5);
+        return this.downfallMap.getRegion(humidities, x, z, xSize, zSize, 0.05, 0.05, 0.5);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
index 9635a88d9..22e0dcc4a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
@@ -90,8 +90,8 @@ public final class BiomeProviderNether
     }
 
     public double getTemperature(double x, double z) {
-        double[] tnResult = temperatureNoise.getValue(null, x, z, 1, 1, temperatureXScale, temperatureZScale, temperatureExponent);
-        double[] fnResult = fuzzinessNoise.getValue(null, x, z, 1, 1, fuzzinessXScale, fuzzinessZScale, fuzzinessExponent);
+        double[] tnResult = temperatureNoise.getRegion(null, x, z, 1, 1, temperatureXScale, temperatureZScale, temperatureExponent);
+        double[] fnResult = fuzzinessNoise.getRegion(null, x, z, 1, 1, fuzzinessXScale, fuzzinessZScale, fuzzinessExponent);
 
         double fuzziness = fnResult[0] * 1.1 + 0.5;
 
@@ -118,8 +118,8 @@ public final class BiomeProviderNether
             temperatures = new double[xSize * zSize];
         }
 
-        double[] tnResult = temperatureNoise.getValue(null, x, z, xSize, zSize, temperatureXScale, temperatureZScale, temperatureExponent);
-        double[] fnResult = fuzzinessNoise.getValue(null, x, z, xSize, zSize, fuzzinessXScale, fuzzinessZScale, fuzzinessExponent);
+        double[] tnResult = temperatureNoise.getRegion(null, x, z, xSize, zSize, temperatureXScale, temperatureZScale, temperatureExponent);
+        double[] fnResult = fuzzinessNoise.getRegion(null, x, z, xSize, zSize, fuzzinessXScale, fuzzinessZScale, fuzzinessExponent);
 
         for (int dx = 0; dx < xSize; dx++)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
index 8affa5997..01403dfc3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
@@ -132,8 +132,8 @@ public final class BiomeProviderOverworld
             temperatures = new double[xSize * zSize];
         }
 
-        double[] tnResult = temperatureNoise.getValue(null, x, z, xSize, zSize, temperatureXScale, temperatureZScale, temperatureExponent);
-        double[] fnResult = fuzzinessNoise.getValue(null, x, z, xSize, zSize, fuzzinessXScale, fuzzinessZScale, fuzzinessExponent);
+        double[] tnResult = temperatureNoise.getRegion(null, x, z, xSize, zSize, temperatureXScale, temperatureZScale, temperatureExponent);
+        double[] fnResult = fuzzinessNoise.getRegion(null, x, z, xSize, zSize, fuzzinessXScale, fuzzinessZScale, fuzzinessExponent);
 
         for (int dx = 0; dx < xSize; dx++)
         {
@@ -169,8 +169,8 @@ public final class BiomeProviderOverworld
             humidities = new double[xSize * zSize];
         }
 
-        double[] hnResult = humidityNoise.getValue(null, x, z, xSize, zSize, humidityXScale, humidityZScale, humidityExponent);
-        double[] fnResult = fuzzinessNoise.getValue(null, x, z, xSize, zSize, fuzzinessXScale, fuzzinessZScale, fuzzinessExponent);
+        double[] hnResult = humidityNoise.getRegion(null, x, z, xSize, zSize, humidityXScale, humidityZScale, humidityExponent);
+        double[] fnResult = fuzzinessNoise.getRegion(null, x, z, xSize, zSize, fuzzinessXScale, fuzzinessZScale, fuzzinessExponent);
 
         for (int dx = 0; dx < xSize; dx++)
         {
@@ -205,8 +205,8 @@ public final class BiomeProviderOverworld
             varieties = new double[xSize * zSize];
         }
 
-        double[] vnResult = varietyNoise.getValue(null, x, z, xSize, zSize, varietyXScale, varietyZScale, varietyExponent);
-        double[] fnResult = fuzzinessNoise.getValue(null, x, z, xSize, zSize, fuzzinessXScale, fuzzinessZScale, fuzzinessExponent);
+        double[] vnResult = varietyNoise.getRegion(null, x, z, xSize, zSize, varietyXScale, varietyZScale, varietyExponent);
+        double[] fnResult = fuzzinessNoise.getRegion(null, x, z, xSize, zSize, fuzzinessXScale, fuzzinessZScale, fuzzinessExponent);
 
         for (int dx = 0; dx < xSize; dx++)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java
index db184f2c9..aa23ce91f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java
@@ -49,7 +49,7 @@ public class IceFloeLargeFeature
                     vec.y = (baseChunkZ + ((float) z / (float) Chunk.CHUNK_SIZE_Z)) * worleyScale;
                     WorleyNoise.getWorleyDistance2d(vec, worley);
                     final float lineScale = 10.0f;
-                    final float lineWidth = (float) (this.perlinNoise.get((baseChunkX * Chunk.CHUNK_SIZE_X + x) / lineScale, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / lineScale) / 2.0 + 0.5);
+                    final float lineWidth = (float) (this.perlinNoise.getValue((baseChunkX * Chunk.CHUNK_SIZE_X + x) / lineScale, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / lineScale) / 2.0 + 0.5);
                     if (MathHelper.unsignedMod(worley.index, 15) != 0) {
                         if (worley.distance > 0.9f + lineWidth * 0.05f) {
                             continue;
